using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_WorkOFFDays
    /// </summary>
    public partial class T_Sys_WorkOFFDays
    {
        public T_Sys_WorkOFFDays()
        { }
        #region  Method


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_WorkOFFDays model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_WorkOFFDays(");
            strSql.Append("F_OffDate,F_OffState,F_remark,F_CreateBy,F_CreateOn,F_DeleteBy,F_DeleteOn)");
            strSql.Append(" values (");
            strSql.Append("@F_OffDate,@F_OffState,@F_remark,@F_CreateBy,@F_CreateOn,@F_DeleteBy,@F_DeleteOn)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OffDate", SqlDbType.Date,3),
                    new SqlParameter("@F_OffState", SqlDbType.Int,4),
                    new SqlParameter("@F_remark", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_CreateBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_DeleteBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeleteOn", SqlDbType.DateTime)};
            parameters[0].Value = model.F_OffDate;
            parameters[1].Value = model.F_OffState;
            parameters[2].Value = model.F_remark;
            parameters[3].Value = model.F_CreateBy;
            parameters[4].Value = model.F_CreateOn;
            parameters[5].Value = model.F_DeleteBy;
            parameters[6].Value = model.F_DeleteOn;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_WorkOFFDays model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_WorkOFFDays set ");
            strSql.Append("F_OffDate=@F_OffDate,");
            strSql.Append("F_OffState=@F_OffState,");
            strSql.Append("F_remark=@F_remark,");
            strSql.Append("F_CreateBy=@F_CreateBy,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_DeleteBy=@F_DeleteBy,");
            strSql.Append("F_DeleteOn=@F_DeleteOn");
            strSql.Append(" where F_OffID=@F_OffID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OffDate", SqlDbType.Date,3),
                    new SqlParameter("@F_OffState", SqlDbType.Int,4),
                    new SqlParameter("@F_remark", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_CreateBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_DeleteBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeleteOn", SqlDbType.DateTime),
                    new SqlParameter("@F_OffID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_OffDate;
            parameters[1].Value = model.F_OffState;
            parameters[2].Value = model.F_remark;
            parameters[3].Value = model.F_CreateBy;
            parameters[4].Value = model.F_CreateOn;
            parameters[5].Value = model.F_DeleteBy;
            parameters[6].Value = model.F_DeleteOn;
            parameters[7].Value = model.F_OffID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool UpdateState(CallCenterApi.Model.T_Sys_WorkOFFDays model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_WorkOFFDays set ");
            strSql.Append("F_OffState=@F_OffState,");
            strSql.Append("F_remark=@F_remark,");
            strSql.Append("F_DeleteBy=@F_DeleteBy,");
            strSql.Append("F_DeleteOn=@F_DeleteOn");
            strSql.Append(" where F_OffDate=@F_OffDate");
            SqlParameter[] parameters = {
                    
                    new SqlParameter("@F_OffState", SqlDbType.Int,4),
                    new SqlParameter("@F_remark", SqlDbType.NVarChar,2000),
                    new SqlParameter("@F_DeleteBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeleteOn", SqlDbType.DateTime),
                    new SqlParameter("@F_OffDate", SqlDbType.Date,3),};
            
            parameters[0].Value = model.F_OffState;
            parameters[1].Value = model.F_remark;
            parameters[2].Value = model.F_DeleteBy;
            parameters[3].Value = model.F_DeleteOn;
            parameters[4].Value = model.F_OffDate;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_OffID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_WorkOFFDays ");
            strSql.Append(" where F_OffID=@F_OffID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OffID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_OffID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public bool DeleteByDate(string date,string usercode,DateTime nowdate)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_WorkOFFDays set ");
            strSql.Append("F_OffState=1,");
            strSql.Append("F_DeleteBy=@F_DeleteBy,");
            strSql.Append("F_DeleteOn=@F_DeleteOn");
            strSql.Append(" where F_OffDate=@F_OffDate");
            SqlParameter[] parameters = {
                new SqlParameter("@F_DeleteBy", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeleteOn", SqlDbType.DateTime),
                    new SqlParameter("@F_OffDate", SqlDbType.Date,3)
            };
            parameters[0].Value = usercode;
            parameters[1].Value = nowdate;
            parameters[2].Value = date;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_OffIDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_WorkOFFDays ");
            strSql.Append(" where F_OffID in (" + F_OffIDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_WorkOFFDays GetModel(int F_OffID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Sys_WorkOFFDays ");
            strSql.Append(" where F_OffID=@F_OffID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OffID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_OffID;

            CallCenterApi.Model.T_Sys_WorkOFFDays model = new CallCenterApi.Model.T_Sys_WorkOFFDays();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                model = DataRowToModel(ds.Tables[0].Rows[0]);
                return model;
            }
            else
            {
                return null;
            }
        }

        public CallCenterApi.Model.T_Sys_WorkOFFDays GetModel(string date)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Sys_WorkOFFDays ");
            strSql.Append(" where F_OffDate=@F_OffDate");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_OffDate", SqlDbType.Date,3)
            };
            parameters[0].Value = date;

            CallCenterApi.Model.T_Sys_WorkOFFDays model = new CallCenterApi.Model.T_Sys_WorkOFFDays();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                model = DataRowToModel(ds.Tables[0].Rows[0]);
                return model;
            }
            else
            {
                return null;
            }
        }

        public Model.T_Sys_WorkOFFDays DataRowToModel(DataRow row)
        {
            Model.T_Sys_WorkOFFDays model = new Model.T_Sys_WorkOFFDays();
            if (row != null)
            {
                if (row["F_OffID"] != null && row["F_OffID"].ToString() != "")
                {
                    model.F_OffID = int.Parse(row["F_OffID"].ToString());
                }
                if (row["F_OffDate"] != null && row["F_OffDate"].ToString() != "")
                {
                    model.F_OffDate = DateTime.Parse(row["F_OffDate"].ToString());
                }
                if (row["F_OffState"] != null && row["F_OffState"].ToString() != "")
                {
                    model.F_OffState = int.Parse(row["F_OffState"].ToString());
                }
                if (row["F_remark"] != null && row["F_remark"].ToString() != "")
                {
                    model.F_remark = row["F_remark"].ToString();
                }
                if (row["F_CreateBy"] != null && row["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = row["F_CreateBy"].ToString();
                }
                if (row["F_CreateOn"] != null && row["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(row["F_CreateOn"].ToString());
                }
                if (row["F_DeleteBy"] != null && row["F_DeleteBy"].ToString() != "")
                {
                    model.F_DeleteBy = row["F_DeleteBy"].ToString();
                }
                if (row["F_DeleteOn"] != null && row["F_DeleteOn"].ToString() != "")
                {
                    model.F_DeleteOn = DateTime.Parse(row["F_DeleteOn"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Sys_WorkOFFDays ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_Sys_WorkOFFDays ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_WorkOFFDays ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_OffID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_WorkOFFDays T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  Method
    }
}
